/*
 * SOURCE:  init.h
 * PROJECT: EasyTeX
 *
 * PURPOSE: function prototypes and defines
 *
 * UPDATES: 12/06/1992 - major rewrite
 *
 * (c)M.Schollmeyer
 */
#ifndef INIT_H
#define INIT_H


    /* main.c */
#define EM_INI_C 0x1000
#define EM_MAIN_C 0x2000
#define EM_PROFILE_C 0x3000
#define EM_MEMORY_C 0x4000

#define EM_NOEDITBUF    0
#define EM_NOVMODE      1
#define EM_OUTOFMEM     2
#define EM_NOCORE       3
#define EM_READERROR    4
#define EM_ININAME      5
#define EM_ALREADYINI   6
#define EM_PROFNOTFOUND 7
#define EM_PROFCORRUPT  8
#define EM_PROFERROR    9
#define EM_BAGARGUMENT 10
#define EM_TOOMANYARGS 11
#define EM_ILLEGALMAGIC 12

void AddToFileArgsList (char *name);
char *GetFromFileArgsList (void);

char *errmsg( unsigned int );

int get_init( int );
int put_init( void );

BOOL maininit( char **, int );
void die( int );

void about( void );
void mem( void );

int settingdlg( void );

void disp_info( int );

#endif

