/*
 * SOURCE:  setting.h
 * PROJECT: EasyTeX
 *
 * PURPOSE: user defined switches and settings
 *
 * UPDATES: 08/15/1991 - major rewrite
 *
 * (c)M.Schollmeyer
 */


#ifndef SETTING_H
#define SETTING_H

#ifndef VIDEO_H
#include "video.h"
#endif

#define DOUBLECLICKSPEED 10
#define MOUSEHIDETIME 1000

#define WORKPAGE 1
#define DOSPAGE  0
#define INI_NAME "et.ini"
#define OVL_NAME "et.ovl"
#define HLP_NAME "et.hlp"
#define DEF_FILE_EXT ".tex"

#define NUMTABS 8 /* spaces per tab for DOS */

#define MAXFILES 20
#define BUFSIZE 124 /* buffer size for strings wich have to do with
                       DOS, thus max. size for a DOS string. */

#define MAGICINIT  "ms91"      // magic chars for initialization file
#define MAGICOVERLAY "msxx91"  // passed from et.ovl to et.exe

#endif
